/*
    Raydium - CQFD Corp.
    http://raydium.org/
    Released under both BSD license and Lesser GPL library license.
    See "license.txt" file.
*/

// Google Sketchup Kmz file converter.
// File->Export->3D Model select kmz file type.
// use kmz_2_tri.php script.
// Multi-texturing, Environnement Mapping not supported


#include "raydium/index.c"

enum{follow,menu}mode=menu;

GLfloat light_color[] = {1.0, 0.9, 0.8, 1.0};

void loadclick(raydium_gui_Object *w)
{
char kmzname[RAYDIUM_MAX_NAME_LEN];
char triname[RAYDIUM_MAX_NAME_LEN];
char tmp[RAYDIUM_MAX_NAME_LEN];
float scale=1;
int verbose=0;

raydium_gui_read_name("Model","edtModelname",kmzname);
raydium_gui_read_name("Model","edtScale",tmp);
scale=atof(tmp);
verbose=raydium_gui_read_name("Model","edtVerbose",tmp);
if (verbose>0) verbose=4;

raydium_register_variable(kmzname,RAYDIUM_REGISTER_STR,"file_name");
raydium_register_variable(&scale,RAYDIUM_REGISTER_FLOAT,"force_scale");
raydium_register_variable(&verbose,RAYDIUM_REGISTER_INT,"verbose");
raydium_file_basename(triname,kmzname);
strcpy(strrchr(triname,'.'),".tri");
raydium_php_exec("kmz_2_tri.php");
raydium_register_variable_unregister_last();
raydium_register_variable_unregister_last();
raydium_register_variable_unregister_last();

if (raydium_ode_element_find("test")!=-1)
    raydium_ode_element_delete_name("test",1);

raydium_ode_object_box_add("test",0,1,RAYDIUM_ODE_AUTODETECT,0,0,RAYDIUM_ODE_STATIC,0,triname);
mode=follow;
raydium_gui_hide();

}

void display(void)
{

if(raydium_key_last==1027)
    exit(0);

if(raydium_mouse_click==2)
    if (mode==menu){
        raydium_gui_hide();
        mode=follow;
    }else{
        raydium_gui_show();
        mode=menu;
    }

raydium_clear_frame();

if (mode==menu)
    raydium_camera_freemove(RAYDIUM_CAMERA_FREEMOVE_FIXED);
else
    raydium_camera_freemove(RAYDIUM_CAMERA_FREEMOVE_NORMAL);

raydium_ode_draw_all(RAYDIUM_ODE_DRAW_NORMAL);
if(raydium_key[GLUT_KEY_F1])
    raydium_ode_draw_all(RAYDIUM_ODE_DRAW_DEBUG);

raydium_osd_logo("logo.tga");

raydium_rendering_finish();
}




int main(int argc, char **argv)
{
int handle;
    raydium_init_args(argc,argv);

    raydium_window_create(640,480,RAYDIUM_RENDERING_WINDOW,"Sketchup to Raydium .tri converter");
    raydium_texture_filter_change(RAYDIUM_TEXTURE_FILTER_TRILINEAR);
    raydium_window_view_perspective(60,0.01,2500);
    raydium_fog_disable();
    raydium_window_view_update();

    raydium_background_color_change(1,0.9,0.7,1);

    raydium_light_enable();
    raydium_light_on(0);
    raydium_light_conf_7f(0,50,150,200,1000000,1,0.9,0.7);

    raydium_gui_theme_load("theme-raydium2.gui");

    handle=raydium_gui_window_create("info",15,25,70,40);
    {
    int i=0;
    char * infos[]={"Raydium Sketchup to Raydium",
                    "Converter",
                    "",
                    "in Sketchup export file in .kmz format",
                    "Enter name and click Load",
                    "Converted .tri file and tga textures",
                    "Are now in your writable directory",
                    "You can specify an output mesh scale",
                    "",0};
    char tmp[4];
        while(infos[i])
            {
            itoa(i,tmp,4);
            raydium_gui_label_create(tmp,handle,50,90-i*10,infos[i],0,0,0);
            i++;
            }

    }

    handle=raydium_gui_window_create("Model",45,75,50,20);
    raydium_gui_widget_sizes(0,0,18);
    raydium_gui_label_create("Model Name",handle,25,85,"Model Name :",0,0,0);
    raydium_gui_widget_sizes(25,4,18);
    raydium_gui_edit_create("edtModelname",handle,47,75,"test.kmz");

    raydium_gui_widget_sizes(0,0,18);
    raydium_gui_label_create("Scale",handle,28,60,"Scale :",0,0,0);
    raydium_gui_widget_sizes(8,4,18);
    raydium_gui_edit_create("edtScale",handle,42,50,"1.0");

    raydium_gui_widget_sizes(4,4,18);
    raydium_gui_check_create("edtVerbose",handle,65,51," Verbose",0);

    raydium_gui_widget_sizes(15,5,18);
    raydium_gui_button_create("btnOk",handle,5,15,"Load",loadclick);



    raydium_gui_show();

    raydium_callback(&display);
    return(0);
}
// EOF
